Index: anches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/SceneIndexComparer.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/SceneIndexComparer.cs	(revision 8270)
+++ 	(revision )
@@ -1,32 +1,0 @@
-using System.Collections;
-using System.Collections.Generic;
-namespace Netron.Diagramming.Core {
-  /// <summary>
-  /// This <see cref="IComparer"/> compares two diagram entities with respect to their scene index.
-  /// A diagram entity is 'less' than another if the scene index is smaller. Note that two distinct entities can never
-  /// have the same scene index. Since this comparer is used in the first place to re-order the <see cref="IPaintable"/> collection
-  /// it will throw an exception if two indices are found to be the same.
-  /// </summary>
-  /// <typeparam name="T"></typeparam>
-  class SceneIndexComparer<T> : IComparer<T> where T : IDiagramEntity {
-    /// <summary>
-    /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
-    /// </summary>
-    /// <param name="x">The first object to compare.</param>
-    /// <param name="y">The second object to compare.</param>
-    /// <returns>
-    /// Value Condition Less than zerox is less than y.Zerox equals y.Greater than zerox is greater than y.
-    /// </returns>
-    public int Compare(T x, T y) {
-      if (x.SceneIndex == y.SceneIndex)
-        throw new InconsistencyException("Inconsistent stack: two entities had the same scene index.");
-
-      if (x.SceneIndex < y.SceneIndex)
-        return -1;
-      else
-        return +1;
-    }
-
-
-  }
-}
Index: anches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Selection.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Selection.cs	(revision 8270)
+++ 	(revision )
@@ -1,439 +1,0 @@
-using System;
-using System.Collections;
-using System.Drawing;
-using System.Drawing.Drawing2D;
-namespace Netron.Diagramming.Core {
-  /// <summary>
-  /// This static class collects functions related to bundle selection
-  /// </summary>
-  public class Selection {
-
-    public Selection(IController controller, IModel model) {
-      this.mController = controller;
-      this.mModel = model;
-    }
-
-    #region Events
-    public event EventHandler OnNewSelection;
-    #endregion
-
-    #region Fields
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Specifies the way entities are selected.
-    /// </summary>
-    // ------------------------------------------------------------------
-    private SelectionTypes mSelectionType = SelectionTypes.Partial;
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// The selected entities.
-    /// </summary>
-    // ------------------------------------------------------------------
-    private CollectionBase<IDiagramEntity> mSelection =
-        new CollectionBase<IDiagramEntity>();
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// A pointer to the model.
-    /// </summary>
-    // ------------------------------------------------------------------
-    private IModel mModel;
-    private IController mController;
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// A pointer to a selected connector.
-    /// </summary>
-    // ------------------------------------------------------------------
-    private IConnector connector;
-
-    #endregion
-
-    #region Properties
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Gets or sets the connector selected by the user.
-    /// </summary>
-    /// <value>The connector.</value>
-    // ------------------------------------------------------------------
-    public IConnector Connector {
-      get {
-        return connector;
-      }
-      set {
-        connector = value;
-      }
-    }
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Gets the Model we're attached to.
-    /// </summary>
-    // ------------------------------------------------------------------
-    public IModel Model {
-      get {
-        return mModel;
-      }
-    }
-
-    public IController Controller {
-      get {
-        return mController;
-      }
-    }
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Gets or sets the selected items.
-    /// </summary>
-    /// <value>The selected items.</value>
-    // ------------------------------------------------------------------
-    public CollectionBase<IDiagramEntity> SelectedItems {
-      get {
-        return mSelection;
-      }
-      internal set {
-        if (value == null || value.Count == 0)
-          return;
-        //clear the current selection
-        Clear();
-
-        mSelection = value;
-        foreach (IDiagramEntity entity in value) {
-          if (entity.Group != null)
-            entity.Group.IsSelected = true;
-          else
-            entity.IsSelected = true;
-        }
-      }
-    }
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Gets the selected items but in flat form, i.e. the entities 
-    /// inside an <see cref="IGroup"/> are collected.
-    /// </summary>
-    // ------------------------------------------------------------------
-    public CollectionBase<IDiagramEntity> FlattenedSelectionItems {
-      get {
-        CollectionBase<IDiagramEntity> flatList =
-            new CollectionBase<IDiagramEntity>();
-        foreach (IDiagramEntity entity in mSelection) {
-          if (entity is IGroup)
-            Utils.TraverseCollect(entity as IGroup, ref flatList);
-          else
-            flatList.Add(entity);
-        }
-        return flatList;
-      }
-    }
-
-    #endregion
-
-    #region Methods
-
-    // ------------------------------------------------------------------
-    /// <summary>
-    /// Creates a Bitmap from the selected entities.  If no entities are
-    /// selected, then 'null' is returned.
-    /// </summary>
-    /// <returns>Bitmap</returns>
-    // ------------------------------------------------------------------
-    public Bitmap ToBitmap() {
-      if (SelectedItems.Count <= 0) {
-        return null;
-      }
-
-      Graphics g = mController.View.Graphics;
-      g.Transform = mController.View.ViewMatrix;
-      g.SmoothingMode = SmoothingMode.HighQuality;
-      Bundle bundle = new Bundle(SelectedItems.Copy());
-      return ImageExporter.FromBundle(bundle, g);
-    }
-
-    public IConnector FindConnector(Predicate<IConnector> predicate) {
-      IConnection con;
-      IShape sh;
-
-      foreach (IDiagramEntity entity in Model.Paintables) {
-        if (typeof(IShape).IsInstanceOfType(entity)) {
-          sh = entity as IShape;
-          foreach (IConnector cn in sh.Connectors) {
-            if (predicate(cn))
-              return cn;
-          }
-        } else if (typeof(IConnection).IsInstanceOfType(entity)) {
-          con = entity as IConnection;
-          if (predicate(con.From))
-            return con.From;
-          if (predicate(con.To))
-            return con.To;
-        }
-      }
-      return null;
-    }
-
-    /// <summary>
-    /// Finds the first connector with the highest z-order under the given point
-    /// </summary>
-    /// <returns></returns>
-    public IConnector FindShapeConnector(Point surfacePoint) {
-
-
-      IShape sh;
-
-      foreach (IDiagramEntity entity in Model.Paintables) {
-        if (typeof(IShape).IsInstanceOfType(entity)) {
-          sh = entity as IShape;
-          foreach (IConnector cn in sh.Connectors) {
-            if (cn.Hit(surfacePoint))
-              return cn;
-          }
-        }
-      }
-      return null;
-    }
-
-    public IConnector FindConnectorAt(Point surfacePoint) {
-      IConnection con;
-      IShape sh;
-
-      foreach (IDiagramEntity entity in Model.Paintables) {
-        if (entity is IShape) {
-          sh = entity as IShape;
-          foreach (IConnector cn in sh.Connectors) {
-            if (cn.Hit(surfacePoint))
-              return cn;
-          }
-        } else if (entity is IConnection) {
-          con = entity as IConnection;
-          if (con.From.Hit(surfacePoint))
-            return con.From;
-          if (con.To.Hit(surfacePoint))
-            return con.To;
-        }
-      }
-      return null;
-    }
-    /// <summary>
-    /// Collects the shapes at the given (transformed surface) location.
-    /// The shapes selected in this way are available 
-    /// </summary>
-    /// <param name="surfacePoint">The surface point.</param>
-    public void CollectEntitiesAt(
-        Point surfacePoint,
-        bool clearSelectionFirst) {
-      if (surfacePoint == Point.Empty)
-        return;
-      if (mModel == null)
-        return;
-
-      // Only change the current selection if the mouse did not hit an 
-      // already selected element and the element is not a group.  This
-      // allows drilling down into group's children.
-      if (mSelection.Count > 0) {
-        foreach (IDiagramEntity entity in mSelection) {
-          if ((entity.Hit(surfacePoint)) &&
-              ((entity is IGroup) == false)) {
-            return;
-          }
-        }
-      }
-
-      // Clear the current selection only if we're supposed to.
-      if (clearSelectionFirst) {
-        Clear();
-      }
-
-      IConnection con;
-      IShape sh;
-
-      //we use the paintables here rather than traversing the scene-graph because only
-      //visible things can be collected
-      //We traverse the paintables from top to bottom since the highest z-order
-      //is at the top of the stack.
-
-      for (int k = Model.Paintables.Count - 1; k >= 0; k--) {
-        IDiagramEntity entity = Model.Paintables[k];
-
-        #region we give priority to the connector selection
-        if (typeof(IConnection).IsInstanceOfType(entity)) {
-          con = entity as IConnection;
-          if (con.From.Hit(surfacePoint)) {
-            connector = con.From;
-            connector.IsSelected = true;
-            this.RaiseOnNewSelection();
-            Invalidate();
-            return;
-          }
-          if (con.To.Hit(surfacePoint)) {
-            connector = con.To;
-            connector.IsSelected = true;
-            this.RaiseOnNewSelection();
-            Invalidate();
-            return;
-          }
-        } else if (entity is IGroup) {
-          //should I care about the connectors at this point...?
-        } else if (entity is IShape) {
-          sh = entity as IShape;
-          foreach (IConnector cn in sh.Connectors) {
-            //if there are connectors attached to the shape connector, the attached ones should be picked up and not the one of the shape
-            if (cn.Hit(surfacePoint) && cn.AttachedConnectors.Count == 0) {
-              connector = cn;
-              connector.IsSelected = true;
-              this.RaiseOnNewSelection();
-              Invalidate();//this will invalidate only the selected connector
-              return; //we hit a connector and quit the selection. If the user intended to select the entity it had to be away from the connector!
-            }
-          }
-        }
-
-        #endregion
-
-        #region no connector was hit, maybe the entity itself
-        if (entity.Hit(surfacePoint)) {
-          SelectEntity(entity, surfacePoint);
-          break;
-        }
-        #endregion
-      }
-      RaiseOnNewSelection();
-
-      // Using a full invalidate is rather expensive, so we'll only 
-      // refresh the current selection.
-      //Controller.View.Invalidate();
-      Invalidate();
-    }
-
-    internal void SelectEntity(IDiagramEntity entity, Point surfacePoint) {
-      // Groups are treated specially because we can drill-down
-      // into the group.  The process of drilling is the first
-      // mouse hit will select the group.  The second mouse hit
-      // will select a child, if there's a child at that point.
-      if (entity is IGroup) {
-        if (entity.IsSelected == false) {
-          entity.IsSelected = true;
-          mSelection.Add(entity);
-        } else {
-          IGroup group = entity as IGroup;
-          for (int j = group.Entities.Count - 1; j >= 0; j--) {
-            IDiagramEntity child = group.Entities[j];
-            if (child.Hit(surfacePoint)) {
-              // Repeat the process because what if this
-              // child is too a group!
-              SelectEntity(child, surfacePoint);
-              group.IsSelected = false;
-              if (mSelection.Contains(group)) {
-                mSelection.Remove(group);
-              }
-              break;
-            }
-          }
-        }
-      }
-        //else if (entity.Group != null)
-        //{
-        //    //entity.Group.IsSelected = true;
-        //    //mSelection.Add(entity.Group);
-        //}
-      else {
-        entity.IsSelected = true;
-        mSelection.Add(entity);
-      }
-    }
-
-    private void RaiseOnNewSelection() {
-      if (OnNewSelection != null)
-        OnNewSelection(null, EventArgs.Empty);
-    }
-    /// <summary>
-    /// Invalidates the current selection (either a connector or a set of entities).
-    /// </summary>
-    public void Invalidate() {
-      if (connector != null)
-        connector.Invalidate();
-
-      foreach (IDiagramEntity entity in mSelection) {
-        entity.Invalidate();
-      }
-    }
-    /// <summary>
-    /// Collects the entities inside the given rectangle.
-    /// </summary>
-    /// <param name="surfaceRectangle">The surface rectangle.</param>
-    public void CollectEntitiesInside(Rectangle surfaceRectangle) {
-      if (surfaceRectangle == Rectangle.Empty)
-        return;
-      this.Clear();
-      foreach (IDiagramEntity entity in Model.Paintables) {
-        //if the entity is part of a group we have to look at the bigger picture
-        if (mSelectionType == SelectionTypes.Inclusion) {
-          if (entity.Group != null) {
-            //the rectangle must contain the whole group
-            if (surfaceRectangle.Contains(entity.Group.Rectangle)) {
-              //add the group if not already present via another group member
-              if (!mSelection.Contains(entity.Group))
-                mSelection.Add(entity.Group);
-              continue;
-            }
-          } else {
-            if (surfaceRectangle.Contains(entity.Rectangle)) {
-
-              mSelection.Add(entity);
-              entity.IsSelected = true;
-            }
-          }
-        } else //the selection requires only partial overlap with the rectangle
-                {
-          if (entity.Group != null) {
-            if (surfaceRectangle.IntersectsWith(entity.Group.Rectangle)) {
-              if (!mSelection.Contains(entity.Group))
-                mSelection.Add(entity.Group);
-              continue;
-            }
-          } else {
-            if (surfaceRectangle.IntersectsWith(entity.Rectangle)) {
-              if (!mSelection.Contains(entity))//it could be a group which got already selected by one of its children
-                            {
-                mSelection.Add(entity);
-                entity.IsSelected = true;
-              }
-            }
-          }
-        }
-
-
-
-      }
-      RaiseOnNewSelection();
-
-    }
-    /// <summary>
-    /// Clears the current selection
-    /// </summary>
-    public void Clear() {
-      if (connector != null) {
-        connector.IsSelected = false;
-        connector = null;
-      }
-
-      if (mController == null || mModel == null)
-        return;
-      //deselect the current ones
-      foreach (IDiagramEntity entity in SelectedItems) {
-        entity.IsSelected = false;
-      }
-      //forget the current state
-      mSelection.Clear();
-      if (Controller.View != null)
-        Controller.View.HideTracker();
-      this.RaiseOnNewSelection();
-    }
-
-
-    #endregion
-  }
-}
Index: anches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Tracing.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Tracing.cs	(revision 8270)
+++ 	(revision )
@@ -1,38 +1,0 @@
-using System.Diagnostics;
-namespace Netron.Diagramming.Core {
-  public static class Tracing {
-    #region Fields
-    /// <summary>
-    /// the serialization switch
-    /// </summary>
-    private static BooleanSwitch mBinarySerializationSwitch = new BooleanSwitch("BinarySerializationSwitch", "This switch enables/disables the ouput of binary serialization information.");
-    /// <summary>
-    /// the deserialization switch
-    /// </summary>
-    private static BooleanSwitch mBinaryDeserializationSwitch = new BooleanSwitch("BinaryDeserializationSwitch", "This switch enables/disables the ouput of binary deserialization information.");
-    #endregion
-
-    #region Properties
-    /// <summary>
-    /// Gets the deserialization switch.
-    /// </summary>
-    /// <value>The deserialization switch.</value>
-    public static BooleanSwitch BinaryDeserializationSwitch {
-      get {
-        return mBinaryDeserializationSwitch;
-      }
-    }
-    /// <summary>
-    /// Gets the serialization switch.
-    /// </summary>
-    /// <value>The serialization switch.</value>
-    public static BooleanSwitch BinarySerializationSwitch {
-      get {
-        return mBinarySerializationSwitch;
-      }
-    }
-    #endregion
-
-
-  }
-}
Index: anches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Utils.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Utils/Utils.cs	(revision 8270)
+++ 	(revision )
@@ -1,288 +1,0 @@
-using System;
-using System.Diagnostics;
-using System.Drawing;
-using System.Drawing.Drawing2D;
-using System.Runtime.Serialization;
-namespace Netron.Diagramming.Core {
-  /// <summary>
-  /// Static class of utility methods
-  /// </summary>
-  public static class Utils {
-    public static void DrawRoundRect(Graphics g, Pen p, Rectangle rectangle) {
-      DrawRoundRect(g, p, rectangle.X, rectangle.Y, rectangle.Width, rectangle.Height, 7F);
-    }
-    public static void DrawRoundRect(Graphics g, Pen p, float X, float Y, float width, float height, float radius) {
-
-      GraphicsPath path = new GraphicsPath();
-      path.AddLine(X + radius, Y, X + width - (radius * 2), Y);
-      path.AddArc(X + width - (radius * 2), Y, radius * 2, radius * 2, 270, 90);
-      path.AddLine(X + width, Y + radius, X + width, Y + height - (radius * 2));
-      path.AddArc(X + width - (radius * 2), Y + height - (radius * 2), radius * 2, radius * 2, 0, 90);
-      path.AddLine(X + width - (radius * 2), Y + height, X + radius, Y + height);
-      path.AddArc(X, Y + height - (radius * 2), radius * 2, radius * 2, 90, 90);
-      path.AddLine(X, Y + height - (radius * 2), X, Y + radius);
-      path.AddArc(X, Y, radius * 2, radius * 2, 180, 90);
-      path.CloseFigure();
-
-      g.DrawPath(p, path);
-      path.Dispose();
-    }
-
-    /// <summary>
-    /// Returns the bounding rectangle of the given collection of entities.
-    /// </summary>
-    /// <param name="collection"></param>
-    /// <returns></returns>
-    public static Rectangle BoundingRectangle(CollectionBase<IDiagramEntity> collection) {
-      //get the bounding rectangle
-      bool first = true;
-      Rectangle rec = Rectangle.Empty;
-      foreach (IDiagramEntity entity in collection) {
-        if (first) {
-          rec = entity.Rectangle;
-          first = false;
-        } else
-          rec = Rectangle.Union(rec, entity.Rectangle);
-      }
-      return rec;
-    }
-
-    /// <summary>
-    /// Depth-first traversal of an <see cref="IGroup"/>
-    /// </summary>
-    /// <param name="group"></param>
-    /// <param name="collection"></param>
-    public static void TraverseCollect(IGroup group, ref CollectionBase<IDiagramEntity> collection) {
-      #region Checks
-      if (group == null)
-        throw new InconsistencyException("Cannot collect entities of a 'null' IGroup");
-      if (collection == null)
-        throw new InconsistencyException("You need to instantiate a collection before using this method.");
-      #endregion
-
-      foreach (IDiagramEntity entity in group.Entities) {
-        if (entity is IGroup)
-          TraverseCollect(entity as IGroup, ref collection);
-        else
-          collection.Add(entity);
-      }
-
-    }
-
-    // Given H,S,L in range of 0-1
-
-    // Returns a Color (RGB struct) in range of 0-255
-
-    /// <summary>
-    /// HSL to RGB conversion.
-    /// </summary>
-    /// <param name="h">The h.</param>
-    /// <param name="sl">The sl.</param>
-    /// <param name="l">The l.</param>
-    /// <returns></returns>
-    public static ColorRGB HSL2RGB(double h, double sl, double l) {
-
-      double v;
-      double r, g, b;
-      r = l;   // default to gray
-      g = l;
-      b = l;
-      v = (l <= 0.5) ? (l * (1.0 + sl)) : (l + sl - l * sl);
-      if (v > 0) {
-        double m;
-        double sv;
-        int sextant;
-        double fract, vsf, mid1, mid2;
-
-        m = l + l - v;
-        sv = (v - m) / v;
-        h *= 6.0;
-        sextant = (int)h;
-        fract = h - sextant;
-        vsf = v * sv * fract;
-        mid1 = m + vsf;
-        mid2 = v - vsf;
-        switch (sextant) {
-          case 0:
-            r = v;
-            g = mid1;
-            b = m;
-            break;
-          case 1:
-            r = mid2;
-            g = v;
-            b = m;
-            break;
-          case 2:
-            r = m;
-            g = v;
-            b = mid1;
-            break;
-          case 3:
-            r = m;
-            g = mid2;
-            b = v;
-            break;
-          case 4:
-            r = mid1;
-            g = m;
-            b = v;
-            break;
-          case 5:
-            r = v;
-            g = m;
-            b = mid2;
-            break;
-        }
-      }
-      ColorRGB rgb = new ColorRGB();
-      rgb.R = Convert.ToByte(r * 255.0f);
-      rgb.G = Convert.ToByte(g * 255.0f);
-      rgb.B = Convert.ToByte(b * 255.0f);
-      return rgb;
-
-    }
-
-    // Given a Color (RGB Struct) in range of 0-255
-
-    // Return H,S,L in range of 0-1
-
-    /// <summary>
-    /// RGB to HSL conversion
-    /// </summary>
-    /// <param name="rgb">The RGB.</param>
-    /// <param name="h">The h.</param>
-    /// <param name="s">The s.</param>
-    /// <param name="l">The l.</param>
-    public static void RGB2HSL(ColorRGB rgb, out double h, out double s, out double l) {
-      double r = rgb.R / 255.0;
-      double g = rgb.G / 255.0;
-      double b = rgb.B / 255.0;
-      double v;
-      double m;
-      double vm;
-      double r2, g2, b2;
-
-      h = 0; // default to black
-      s = 0;
-      l = 0;
-      v = Math.Max(r, g);
-      v = Math.Max(v, b);
-      m = Math.Min(r, g);
-      m = Math.Min(m, b);
-
-      l = (m + v) / 2.0;
-      if (l <= 0.0) {
-        return;
-      }
-      vm = v - m;
-      s = vm;
-      if (s > 0.0) {
-        s /= (l <= 0.5) ? (v + m) : (2.0 - v - m);
-      } else {
-        return;
-      }
-      r2 = (v - r) / vm;
-      g2 = (v - g) / vm;
-      b2 = (v - b) / vm;
-      if (r == v) {
-        h = (g == m ? 5.0 + b2 : 1.0 - g2);
-      } else if (g == v) {
-        h = (b == m ? 1.0 + r2 : 3.0 - b2);
-      } else {
-        h = (r == m ? 3.0 + g2 : 5.0 - r2);
-      }
-      h /= 6.0;
-    }
-    /// <summary>
-    /// Constrains the type.
-    /// </summary>
-    /// <param name="type">The type.</param>
-    public static void ConstrainType(Type type) {
-      bool serializable = type.IsSerializable;
-      if (serializable == false) {
-        string message = "The type " + type + " is not serializable";
-        throw new SerializationException(message);
-      }
-      bool genericType = type.IsGenericType;
-
-      if (genericType) {
-        Type[] typeArguments = type.GetGenericArguments();
-        Debug.Assert(typeArguments.Length >= 1);
-        Array.ForEach(typeArguments, ConstrainType);
-      }
-    }
-
-
-  }
-  /// <summary>
-  /// Utility struct for color conversions
-  /// </summary>
-  public struct ColorRGB {
-    #region Fields
-    private byte r;
-    private byte g;
-    private byte b;
-    #endregion
-
-    /// <summary>
-    /// Gets or sets the Red value.
-    /// </summary>
-    /// <value>The R.</value>
-    public byte R {
-      get { return r; }
-      set { r = value; }
-    }
-
-
-    /// <summary>
-    /// Gets or sets the Green value.
-    /// </summary>
-    /// <value>The G.</value>
-    public byte G {
-      get { return g; }
-      set { g = value; }
-    }
-
-
-
-    /// <summary>
-    /// Gets or sets the Blue value.
-    /// </summary>
-    /// <value>The B.</value>
-    public byte B {
-      get { return b; }
-      set { b = value; }
-    }
-    /// <summary>
-    /// Initializes a new instance of the <see cref="T:ColorRGB"/> class.
-    /// </summary>
-    /// <param name="value">The value.</param>
-    public ColorRGB(Color value) {
-      this.r = value.R;
-      this.g = value.G;
-      this.b = value.B;
-    }
-    /// <summary>
-    /// Implicit conversion of the specified RGB.
-    /// </summary>
-    /// <param name="rgb">The RGB.</param>
-    /// <returns></returns>
-    public static implicit operator Color(ColorRGB rgb) {
-      Color c = Color.FromArgb(rgb.R, rgb.G, rgb.B);
-      return c;
-    }
-    /// <summary>
-    /// Explicit conversion of the specified c.
-    /// </summary>
-    /// <param name="c">The c.</param>
-    /// <returns></returns>
-    public static explicit operator ColorRGB(Color c) {
-      return new ColorRGB(c);
-    }
-  }
-
-
-
-
-}
Index: anches/HeuristicLab.Hive.Azure/LocalTestRun.testrunconfig
===================================================================
--- /branches/HeuristicLab.Hive.Azure/LocalTestRun.testrunconfig	(revision 8270)
+++ 	(revision )
@@ -1,25 +1,0 @@
-﻿<?xml version="1.0" encoding="UTF-8"?>
-<TestSettings name="Local Test Run" id="f9392825-866f-4434-be36-358db28f0c59" xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2010">
-  <Description>This is a default test run configuration for a local test run.</Description>
-  <Execution hostProcessPlatform="MSIL">
-    <TestTypeSpecific>
-      <UnitTestRunConfig testTypeId="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b">
-        <AssemblyResolution>
-          <TestDirectory useLoadContext="true" />
-        </AssemblyResolution>
-      </UnitTestRunConfig>
-      <WebTestRunConfiguration testTypeId="4e7599fa-5ecb-43e9-a887-cd63cf72d207">
-        <Browser name="Internet Explorer 7.0">
-          <Headers>
-            <Header name="User-Agent" value="Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1)" />
-            <Header name="Accept" value="*/*" />
-            <Header name="Accept-Language" value="{{$IEAcceptLanguage}}" />
-            <Header name="Accept-Encoding" value="GZIP" />
-          </Headers>
-        </Browser>
-      </WebTestRunConfiguration>
-    </TestTypeSpecific>
-    <AgentRule name="LocalMachineDefaultRole">
-    </AgentRule>
-  </Execution>
-</TestSettings>
Index: anches/HeuristicLab.Hive.Azure/MergeConfigs.cmd
===================================================================
--- /branches/HeuristicLab.Hive.Azure/MergeConfigs.cmd	(revision 8270)
+++ 	(revision )
@@ -1,18 +1,0 @@
-@echo off
-
-IF "%Outdir%"=="" (
-  SET Outdir=bin\
-  SET INTERACTIVE=1
-)
-
-echo Recreating HeuristicLab 3.3.exe.config...
-copy /Y "%Outdir%app.config" "%Outdir%HeuristicLab 3.3.exe.config"
-
-echo Merging...
-FOR /F "tokens=*" %%A IN ('dir /B "%Outdir%*.dll.config"') DO (
-  ConfigMerger "%Outdir%%%A" "%Outdir%HeuristicLab 3.3.exe.config"
-)
-
-IF "%INTERACTIVE%"=="1" (
-  pause
-)