Index: /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 8287)
+++ /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 8288)
@@ -115,4 +115,5 @@
     <Compile Include="MultiObjective\RankAndCrowdingSorter.cs" />
     <Compile Include="Plugin.cs" />
+    <Compile Include="ProgrammableAnalyzer.cs" />
     <Compile Include="ShakingOperator.cs" />
     <Compile Include="UserDefinedCrossover.cs" />
@@ -163,4 +164,9 @@
       <Private>False</Private>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Operators.Programmable\3.3\HeuristicLab.Operators.Programmable-3.3.csproj">
+      <Project>{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}</Project>
+      <Name>HeuristicLab.Operators.Programmable-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
       <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
Index: /trunk/sources/HeuristicLab.Optimization.Operators/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Operators/3.3/Plugin.cs.frame	(revision 8287)
+++ /trunk/sources/HeuristicLab.Optimization.Operators/3.3/Plugin.cs.frame	(revision 8288)
@@ -33,4 +33,5 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Operators.Programmable", "3.3")]
   [PluginDependency("HeuristicLab.Optimization","3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
Index: /trunk/sources/HeuristicLab.Optimization.Operators/3.3/ProgrammableAnalyzer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Operators/3.3/ProgrammableAnalyzer.cs	(revision 8288)
+++ /trunk/sources/HeuristicLab.Optimization.Operators/3.3/ProgrammableAnalyzer.cs	(revision 8288)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators.Programmable;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators {
+
+  [Item("ProgrammableAnalyzer", "An analyzer that can be programmed for arbitrary needs.")]
+  [StorableClass]
+  public class ProgrammableAnalyzer : ProgrammableSingleSuccessorOperator, IAnalyzer {
+    public virtual bool EnabledByDefault {
+      get { return false; }
+    }
+
+    [StorableConstructor]
+    protected ProgrammableAnalyzer(bool deserializing) : base(deserializing) { }
+    protected ProgrammableAnalyzer(ProgrammableAnalyzer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ProgrammableAnalyzer()
+      : base() {
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the solutions."));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the solution should be stored."));
+      Parameters.ForEach(x => x.Hidden = false);
+
+      SelectNamespace("HeuristicLab.Optimization");
+      SelectNamespace("HeuristicLab.Optimization.Operators");
+      Assemblies[typeof(HeuristicLab.Optimization.ResultCollection).Assembly] = true;
+      Assemblies[typeof(HeuristicLab.Optimization.Operators.ProgrammableAnalyzer).Assembly] = true;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ProgrammableAnalyzer(this, cloner);
+    }
+  }
+}